/**
 * Copyright (C) 2010-2011 enStratusNetworks LLC
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.jclouds.azure;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Locale;

import org.dasein.cloud.CloudException;
import org.dasein.cloud.InternalException;
import org.dasein.cloud.dc.DataCenter;
import org.dasein.cloud.dc.DataCenterServices;
import org.dasein.cloud.dc.Region;

public class DataCenters implements DataCenterServices {
    public DataCenters(Azure azure) { }
    
    @Override
    public DataCenter getDataCenter(String dataCenterId) throws InternalException, CloudException {
        if( dataCenterId.equals("sat1") ) {
            DataCenter dc = new DataCenter();
            
            dc.setActive(true);
            dc.setAvailable(true);
            dc.setName("SAT 1");
            dc.setProviderDataCenterId("sat1");
            dc.setRegionId("ussw1");
            return dc;
        }
        return null;
    }

    @Override
    public String getProviderTermForDataCenter(Locale locale) {
        return "data center";
    }

    @Override
    public String getProviderTermForRegion(Locale locale) {
        return "region";
    }

    @Override
    public Region getRegion(String regionId) throws InternalException, CloudException {
        if( regionId.equals("ussw1") ) {
            Region region = new Region();
            
            region.setActive(true);
            region.setAvailable(true);
            region.setName("US - Southwest 1");
            region.setProviderRegionId("ussw1");
            return region;
        }
        return null;
    }

    @Override
    public Collection<DataCenter> listDataCenters(String regionId) throws InternalException, CloudException {
        ArrayList<DataCenter> dataCenters= new ArrayList<DataCenter>();
        
        if( regionId.equals("ussw1") ) {
            DataCenter dc = new DataCenter();
            
            dc.setActive(true);
            dc.setAvailable(true);
            dc.setName("SAT 1");
            dc.setProviderDataCenterId("sat1");
            dc.setRegionId("ussw1");
            dataCenters.add(dc);
        }
        return dataCenters;
    }

    @Override
    public Collection<Region> listRegions() throws InternalException, CloudException {
        ArrayList<Region> regions = new ArrayList<Region>();
        Region region = new Region();
        
        region.setActive(true);
        region.setAvailable(true);
        region.setName("US - Southwest 1");
        region.setProviderRegionId("ussw1");
        regions.add(region);
        return regions;
    }
}
